﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using System.Text;

public partial class DefaultPage : System.Web.UI.Page
{

	protected void Page_Load(object sender, EventArgs e)
	{

	}

	private List<DockState> CurrentDockStates
	{
		get
		{
			List<DockState> _currentDockStates = (List<DockState>)Session["CurrentDockStatesDynamicDocks"];
			if (Object.Equals(_currentDockStates, null))
			{
				_currentDockStates = new List<DockState>();
				Session["CurrentDockStatesDynamicDocks"] = _currentDockStates;
			}
			return _currentDockStates;
		}
		set
		{
			Session["CurrentDockStatesDynamicDocks"] = value;
		}
	}

	private RadDock CreateRadDockFromState(DockState state)
	{
		RadDock dock = new RadDock();
		dock.DockMode = DockMode.Docked;
		dock.ID = string.Format("RadDock{0}", state.UniqueName);
		dock.ApplyState(state);
		dock.Commands.Add(new DockCloseCommand());
		dock.Commands.Add(new DockExpandCollapseCommand());

		return dock;
	}

	private RadDock CreateRadDock()
	{
		RadDock dock = new RadDock();
		dock.DockMode = DockMode.Docked;
		dock.UniqueName = Guid.NewGuid().ToString().Replace("-", "a");
		dock.ID = string.Format("RadDock{0}", dock.UniqueName);
		dock.Title = "Dock";
		dock.Text = string.Format("Added at {0}", DateTime.Now);
		dock.Width = Unit.Pixel(300);

		dock.Commands.Add(new DockCloseCommand());
		dock.Commands.Add(new DockExpandCollapseCommand());

		return dock;
	}

	private void CreateSaveStateTrigger(RadDock dock)
	{
		dock.AutoPostBack = true;
		dock.CommandsAutoPostBack = true;
	}

	protected void Page_Init(object sender, EventArgs e)
	{
		
		for (int i = 0; i < CurrentDockStates.Count; i++)
		{
			RadDock dock = CreateRadDockFromState(CurrentDockStates[i]);
			RadDockLayout1.Controls.Add(dock);		
			CreateSaveStateTrigger(dock);
		}
	}

	protected void RadDockLayout1_LoadDockLayout(object sender, DockLayoutEventArgs e)
	{
		foreach (DockState state in CurrentDockStates)
		{
			e.Positions[state.UniqueName] = state.DockZoneID;
			e.Indices[state.UniqueName] = state.Index;
		}
	}

	protected void RadDockLayout1_SaveDockLayout(object sender, DockLayoutEventArgs e)
	{
		CurrentDockStates = RadDockLayout1.GetRegisteredDocksState();
	}

	protected void ButtonAddDock_Click(object sender, EventArgs e)
	{
		RadDock dock = CreateRadDock();
		RadDockZone1.Controls.Add(dock);
		RadScriptManager.RegisterStartupScript(this, this.GetType(), "MoveDock",
			string.Format(@"function _moveDock() {{
            Sys.Application.remove_load(_moveDock);
			$find('{1}').dock($find('{0}'),{2});
            }};
            Sys.Application.add_load(_moveDock);", dock.ClientID, RadDockZone1.ClientID, RadDockZone1.Docks.Count), true);
		CreateSaveStateTrigger(dock);
	}

}